package model

type Commission struct {
	CommissionType    CommissionType `json:"commission_type"`
	CustomerType      CustomerType   `json:"customer_type"`
	PartnerCode       string         `json:"partner_code"`
	CommissionPercent float64        `json:"commission_percent"`
}


// txnProcessCommissionType
type CommissionType string

const (
	InputTransaction      CommissionType = "INPUT_TRANSACTION"
	OutputTransaction     CommissionType = "OUTPUT_TRANSACTION"
	TransactionCommission CommissionType = "TRANSACTION_COMMISSION"
	TransferToMarket      CommissionType = "TRANSFER_TO_MARKET"
)

type GetCommissionArg struct {
	PartnerCode    string `json:"partner_code"`
	CustomerType   string `json:"customer_type"`
	CommissionType string `json:"commission_type"`
}

func (c CommissionType) String() string {
	return string(c)
}